var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var association_select_exports = {};
__export(association_select_exports, {
  default: () => association_select_default
});
module.exports = __toCommonJS(association_select_exports);
var import_server = require("@nocobase/server");
class association_select_default extends import_server.Migration {
  appVersion = "<0.9.3-alpha.1";
  async up() {
    const result = await this.app.version.satisfies("<0.9.2-alpha.5");
    if (!result) {
      return;
    }
    const r = this.db.getRepository("uiSchemas");
    const items = await r.find({
      filter: {
        "schema.x-designer": "AssociationSelect.Designer"
      }
    });
    await this.db.sequelize.transaction(async (transaction) => {
      for (const item of items) {
        const schema = item.schema;
        if (!schema["x-collection-field"]) {
          continue;
        }
        const field = this.db.getFieldByPath(schema["x-collection-field"]);
        if (!field) {
          continue;
        }
        if (["hasOne", "belongsTo"].includes(field.type)) {
          schema["type"] = "object";
        } else if (["hasMany", "belongsToMany"].includes(field.type)) {
          schema["type"] = "array";
        } else {
          continue;
        }
        schema["x-designer"] = "FormItem.Designer";
        schema["x-component"] = "CollectionField";
        item.set("schema", schema);
        await item.save({ transaction });
      }
    });
  }
}
